#ifndef BASE_ORTHO_HPP
#define BASE_ORTHO_HPP

#include <cmath>
#include <iostream>

#include "complexe.hpp"

class base_orthogonal{
    int n;
    double * base;
    double * base_ortho;
    int index(int i, int j){ return i*n +j;}
    public:
    base_orthogonal(){
        n=0;
        base = NULL;
        base_ortho = NULL;
    }
    base_orthogonal(int size){
        n=size;
        base = new double[n*n];
        base_ortho = new double[n*n];
        for(int i=0;i<n*n;i++){
            base[i] =0.0;
            base_ortho[i]=0.0;
        }
    }
    base_orthogonal(const base_orthogonal & x){
        n=x.n;
        if(x.base != NULL){
            base = new double[n*n];
            base_ortho = new double[n*n];
            for(int i=0;i<n*n;i++){
                base[i] =x.base[i];
                base_ortho[i]=x.base_ortho[i];
            }   
        }
    }
    ~base_orthogonal(){
       if(base != NULL){
           delete [] base;
           delete [] base_ortho;
        } 
    };
    double getb(int, int);
    void setb(double, int, int);
    double getbo(int, int);
    void setbo(double, int, int);
    base_orthogonal & operator =(const base_orthogonal & x);
    void projection(double *, double *, double *);
    void orthogonalisation();
};




#endif
