#include <cmath>
#include <iostream>
#include "base_ortho.hpp"

using namespace std;

base_orthogonal & base_orthogonal::operator =(const base_orthogonal & x){
    if(&x != this){
        n=x.n;
        if(base != NULL){
            delete [] base;
            delete [] base_ortho;
        }
        if(x.base != NULL){
            base = new double[n*n];
            base_ortho = new double[n*n];
            for(int i=0;i<n*n;i++){
                base[i] =x.base[i];
                base_ortho[i]=x.base_ortho[i];
            }   
        }
    }
    return *this;
}

double base_orthogonal::getb(int i, int j){
    return base[index(i,j)];
}

double base_orthogonal::getbo(int i, int j){
    return base_ortho[index(i,j)];
}
void base_orthogonal::setb(double x, int i , int j){
    base[index(i,j)]=x; 
}
void base_orthogonal::setbo(double x, int i , int j){
    base_ortho[index(i,j)]=x; 
}

void base_orthogonal::projection(double *p, double * v, double * u){
    double uv=0.0, uu=0.0;
    for(int i =0;i<n;i++){
        uv= uv+v[i]*u[i];
        uu= uu+u[i]*u[i];
    }
     for(int i =0;i<n;i++){
        p[i]=(uv/uu)*u[i];
    }
}

void base_orthogonal::orthogonalisation(){
    double * vk; 
    double * ul;
    double * p = new double[n]; 
    for(int i =0;i<n;i++){
        base_ortho[i]= base[i];
    }
    for(int k =1;k<n;k++){
        for(int i =0;i<n;i++){
            base_ortho[index(k,i)]= base[index(k,i)];
        }
        vk = &(base[index(k,0)]);
        for(int l =0;l<k;l++){
            ul = &(base_ortho[index(l,0)]);
            projection(p, vk,ul);
            for(int i =0;i<n;i++){
                base_ortho[index(k,i)] -= p[i];
            }
        }
    }
    delete [] p;
}
