#include <iostream>

#include "racine_unite.hpp"
#include "poly2D1.hpp"
#include "base_ortho.hpp"

int main() {
   racineUnite xk1(1,3);
   racineUnite x3; 
   x3 = xk1*xk1*xk1;
   complexe un(1.0,0.0);
   
   cout<<" res 1>>>> "<<(x3.calculeComplexe()-un).module()<<endl;

   racineUnite xk2(2,3);
   x3 = xk2*xk2*xk2;
   cout<<" res 2>>>> "<<(x3.calculeComplexe()-un).module()<<endl;

   base_orthogonal b(3);
   b.setb(1.0,0,0), b.setb(1.0,0,1), b.setb(0.0,0,2);
   b.setb(1.0,1,0), b.setb(-2.0,1,1), b.setb(2.0,1,2);
   b.setb(0.0,2,0), b.setb(1.0,2,1), b.setb(3.0,2,2);

   b.orthogonalisation();
   cout<<" v1>>> "<<b.getbo(0,0)<<" "<<b.getbo(0,1)<<" "<<b.getbo(0,2)<<endl;
   cout<<" v2>>> "<<b.getbo(1,0)<<" "<<b.getbo(1,1)<<" "<<b.getbo(1,2)<<endl;
   cout<<" v3>>> "<<b.getbo(2,0)<<" "<<b.getbo(2,1)<<" "<<b.getbo(2,2)<<endl;

   POLY2D1<double> P1(1.0,2.0,0.1,0.0,0.0,0.0);
   POLY2D1<double> P2(1.0,-1.0,0.4,0.0,0.0,0.0);
   POLY2D1<double> P3;
   P3 = P1*P2;
   double b1=P3.getb1();
   double b2=P3.getb2();
   double c=P3.getc();
   cout<<" "<<b1<<" "<<b2<<" "<<c<<endl;
   return 0;
}
